/**
 * Mihailescu Maria Elena
 * grupa 331CC
 * Connect Four pe LED-uri
 */
#ifndef _PROJECT_STRUCT_H_
#define _PROJECT_STRUCT_H

#define R 1
#define V 2
#define S 0

/* 7segment LED Display Init */
#define SEG0 PA0
#define SEG1 PA1
#define SEG2 PA2
#define SEG3 PA3
#define SEG4 PA4
#define SEG5 PA5
#define SEG6 PA6
#define GND1 PC0
#define GND2 PC1

/* Buttons */ 
#define RESET_GAME PC5 //doesn't work
#define LEFT PC4
#define RIGHT PC3
#define ENTER PC2

/* defines a structure for a LED entry. 
 * it contains:
 * red - the port for the red LED
 * green - the port for the GREEN LED
 * gnd - the port for the GROUND
 * state - state of the LED: S - turned off, R - red, V - green
 */
typedef struct {
	char red;
	char green;
	char gnd;
	char state;
} led;

char contor = 0;
char last_contor;
/* first turn is for the red player */
char turn = R;
char time = 9;
int place = 0;

/* global led matrix */
led matrix[5][5];

/* init matix */
void init()
{
	/* deactivate JTAG */
	MCUCR |= (1<<JTD);
	MCUCR |= (1<<JTD);

	/* Line 1 */
	matrix[0][0].green = PB0;
	matrix[0][0].red   = PB5;
	matrix[0][0].gnd   = PD2;
	matrix[0][0].state = R;
	
	matrix[0][1].green = PB0;
	matrix[0][1].red   = PB5;
	matrix[0][1].gnd   = PD3;
	matrix[0][1].state = S;
	
	matrix[0][2].green = PB0;
	matrix[0][2].red   = PB5;
	matrix[0][2].gnd   = PD4;
	matrix[0][2].state = S;
	
	matrix[0][3].green = PB0;
	matrix[0][3].red   = PB5;
	matrix[0][3].gnd   = PD5;
	matrix[0][3].state = S;
	
	matrix[0][4].green = PB0;
	matrix[0][4].red   = PB5;
	matrix[0][4].gnd   = PD7;
	matrix[0][4].state = S;

	/* Line 2 */
	matrix[1][0].green = PB1;
	matrix[1][0].red   = PB6;
	matrix[1][0].gnd   = PD2;
	matrix[1][0].state = S;
	
	matrix[1][1].green = PB1;
	matrix[1][1].red   = PB6;
	matrix[1][1].gnd   = PD3;
	matrix[1][1].state = S;
	
	matrix[1][2].green = PB1;
	matrix[1][2].red   = PB6;
	matrix[1][2].gnd   = PD4;
	matrix[1][2].state = S;
	
	matrix[1][3].green = PB1;
	matrix[1][3].red   = PB6;
	matrix[1][3].gnd   = PD5;
	matrix[1][3].state = S;
	
	matrix[1][4].green = PB1;
	matrix[1][4].red   = PB6;
	matrix[1][4].gnd   = PD7;
	matrix[1][4].state = S;

	/* Line 3 */
	matrix[2][0].green = PB2;
	matrix[2][0].red   = PB7;
	matrix[2][0].gnd   = PD2;
	matrix[2][0].state = S;
	
	matrix[2][1].green = PB2;
	matrix[2][1].red   = PB7;
	matrix[2][1].gnd   = PD3;
	matrix[2][1].state = S;
	
	matrix[2][2].green = PB2;
	matrix[2][2].red   = PB7;
	matrix[2][2].gnd   = PD4;
	matrix[2][2].state = S;
	
	matrix[2][3].green = PB2;
	matrix[2][3].red   = PB7;
	matrix[2][3].gnd   = PD5;
	matrix[2][3].state = S;
	
	matrix[2][4].green = PB2;
	matrix[2][4].red   = PB7;
	matrix[2][4].gnd   = PD7;
	matrix[2][4].state = S;

	/* Line 4 */
	matrix[3][0].green = PB3;
	matrix[3][0].red   = PD0;
	matrix[3][0].gnd   = PD2;
	matrix[3][0].state = S;
	
	matrix[3][1].green = PB3;
	matrix[3][1].red   = PD0;
	matrix[3][1].gnd   = PD3;
	matrix[3][1].state = S;
	
	matrix[3][2].green = PB3;
	matrix[3][2].red   = PD0;
	matrix[3][2].gnd   = PD4;
	matrix[3][2].state = S;
	
	matrix[3][3].green = PB3;
	matrix[3][3].red   = PD0;
	matrix[3][3].gnd   = PD5;
	matrix[3][3].state = S;
	
	matrix[3][4].green = PB3;
	matrix[3][4].red   = PD0;
	matrix[3][4].gnd   = PD7;
	matrix[3][4].state = S;

	/* Line 5 */
	matrix[4][0].green = PB4;
	matrix[4][0].red   = PD1;
	matrix[4][0].gnd   = PD2;
	matrix[4][0].state = S;
	
	matrix[4][1].green = PB4;
	matrix[4][1].red   = PD1;
	matrix[4][1].gnd   = PD3;
	matrix[4][1].state = S;
	
	matrix[4][2].green = PB4;
	matrix[4][2].red   = PD1;
	matrix[4][2].gnd   = PD4;
	matrix[4][2].state = S;
	
	matrix[4][3].green = PB4;
	matrix[4][3].red   = PD1;
	matrix[4][3].gnd   = PD5;
	matrix[4][3].state = S;
	
	matrix[4][4].green = PB4;
	matrix[4][4].red   = PD1;
	matrix[4][4].gnd   = PD7;
	matrix[4][4].state = S;
	
}

void IO_init()
{

	/* Led-urile sunt puse ca iesire */
	DDRB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4)
		 |  (1 << PB5) | (1 << PB6) | (1 << PB7);
	DDRD |= (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4)
		 |  (1 << PD5) | (1 << PD7);

	/* Led-urile afisajului sunt puse ca iesire */
	DDRA |= (1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4)
		 |  (1 << PA5) | (1 << PA6) | (1 << PA7);
	/* gnd-urile pentru afisaj */
	DDRC |= (1 << PC0) | (1 << PC1);
	
	/* Butoanele sunt puse ca intrare cu rezistenta de pull-up */
	DDRC &= ~((1 << LEFT) | (1 << RIGHT) | (1 << ENTER) | (1 << RESET_GAME));
	PORTC |= ((1 << LEFT) | (1 << RIGHT) | (1 << ENTER) | (1 << RESET_GAME));

	/* Intreruperi activate pentru butoane */
	PCICR = (1 << PCIE2);
	PCMSK2 = (1 << PCINT18) | (1 << PCINT19) | (1 << PCINT20) | (1 << PCINT21);
	
}

/* print numbers for display */
void print_nr(char n)
{
	PORTA = 0;
	PORTC |= (1 << GND1);
	
	if(n == 0){
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG2);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG4);
		PORTA |= (1 << SEG5);
		PORTA |= (1 << SEG6);
	} else if(n == 1){
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG4);
	} else if(n == 2){
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG5);
		PORTA |= (1 << SEG6);
	}else if(n == 3){
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG4);
		PORTA |= (1 << SEG6);
	} else if(n == 4){
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG2);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG4);
	} else if(n == 5){
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG2);
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG4);
		PORTA |= (1 << SEG6);
	} else if(n == 6){
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG2);
		PORTA |= (1 << SEG4);
		PORTA |= (1 << SEG5);
		PORTA |= (1 << SEG6);
	} else if(n == 7){
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG4);
	} else if(n == 8){
		PORTA = ~PORTA;
	} else if(n == 9){
		PORTA |= (1 << SEG0);
		PORTA |= (1 << SEG1);
		PORTA |= (1 << SEG2);
		PORTA |= (1 << SEG3);
		PORTA |= (1 << SEG4);
		PORTA |= (1 << SEG6);
	}
}

int is_win()
{
	/* Linii */
	int i;
	for(i = 4; i >= 0; i --){
		if(matrix[i][0].state == matrix[i][1].state 
			&& matrix[i][1].state == matrix[i][2].state
			&& matrix[i][2].state == matrix[i][3].state
			&& matrix[i][0].state != S)
				return matrix[i][0].state;
		if(matrix[i][1].state == matrix[i][2].state 
			&& matrix[i][2].state == matrix[i][3].state
			&& matrix[i][3].state == matrix[i][4].state
			&& matrix[i][1].state != S)
				return matrix[i][1].state;
	}
	
	/* Coloane */
	for(i = 0; i < 5; i ++){
		if(matrix[0][i].state == matrix[1][i].state 
			&& matrix[1][i].state == matrix[2][i].state
			&& matrix[2][i].state == matrix[3][i].state
			&& matrix[0][i].state != S)
				return matrix[0][i].state;
		if(matrix[1][i].state == matrix[2][i].state 
			&& matrix[2][i].state == matrix[3][i].state
			&& matrix[3][i].state == matrix[4][i].state
			&& matrix[1][i].state != S)
				return matrix[1][i].state;
	}
	
	/*
	   (0,0) (0,1) (0,2) (0,3) (0,4)
	   (1,0) (1,1) (1,2) (1,3) (1,4)
	   (2,0) (2,1) (2,2) (2,3) (2,4)
	   (3,0) (3,1) (3,2) (3,3) (3,4)
	   (4,0) (4,1) (4,2) (4,3) (4,4)
	*/
	
	/* Diagonale */
	if(matrix[1][0].state == matrix[2][1].state
		&& matrix[2][1].state == matrix[3][2].state
		&& matrix[3][2].state == matrix[4][3].state
		&& matrix[1][0].state != S)
			return matrix[1][0].state;
	
	if(matrix[0][1].state == matrix[1][2].state
		&& matrix[1][2].state == matrix[2][3].state
		&& matrix[2][3].state == matrix[3][4].state
		&& matrix[0][1].state != S)
			return matrix[0][1].state;
	
	if(matrix[3][0].state == matrix[2][1].state
		&& matrix[2][1].state == matrix[1][2].state
		&& matrix[1][2].state == matrix[0][3].state
		&& matrix[3][0].state != S)
			return matrix[3][0].state;
	
	if(matrix[1][4].state == matrix[2][3].state
		&& matrix[2][3].state == matrix[3][2].state
		&& matrix[3][2].state == matrix[4][1].state
		&& matrix[1][4].state != S)
			return matrix[1][4].state;
	
	/*
	   (0,0) (0,1) (0,2) (0,3) (0,4)
	   (1,0) (1,1) (1,2) (1,3) (1,4)
	   (2,0) (2,1) (2,2) (2,3) (2,4)
	   (3,0) (3,1) (3,2) (3,3) (3,4)
	   (4,0) (4,1) (4,2) (4,3) (4,4)
	*/
	
	if(matrix[0][4].state == matrix[1][3].state
		&& matrix[1][3].state == matrix[2][2].state
		&& matrix[2][2].state == matrix[3][1].state
		&& matrix[0][4].state != S)
			return matrix[0][4].state;
	
	if(matrix[1][3].state == matrix[2][2].state
		&& matrix[2][2].state == matrix[3][1].state
		&& matrix[3][1].state == matrix[4][0].state
		&& matrix[1][3].state != S)
			return matrix[1][3].state;

	if(matrix[0][0].state == matrix[1][1].state
		&& matrix[1][1].state == matrix[2][2].state
		&& matrix[2][2].state == matrix[3][3].state
		&& matrix[0][0].state != S)
			return matrix[0][0].state;
	
	if(matrix[1][1].state == matrix[2][2].state
		&& matrix[2][2].state == matrix[3][3].state
		&& matrix[3][3].state == matrix[4][4].state
		&& matrix[1][1].state != S)
			return matrix[1][1].state;
	return S;

}


#endif